<?php
// $Id: wsapi.admin.inc,v 1.1.2.1 2009/05/16 04:46:27 brmassa Exp $
/**
 * @author Web Services Dev Team
 * @file
 *   Show the help pages.
 */

/**
 * The module settings page
 *
 * @ingroup form
 */
function _wsapi_settings() {
  $settings = variable_get('wsapi_settings', array());
  $form['wsapi_settings'] = array(
    '#collapsible'  => TRUE,
    '#tree'         => TRUE,
    '#title'        => t('Items'),
    '#type'         => 'fieldset',
  );

  // Services
  module_load_include('inc', 'webservices');
  $services         = webservices_service_get_all();
  $form['wsapi_settings']['service'] = array(
    '#title'        => t('Services'),
    '#tree'         => TRUE,
    '#type'         => 'fieldset',
  );
  foreach ($services as $service_data) {
    $service = &$service_data['#method'];
    $form['wsapi_settings']['service'][$service] = array(
      '#default_value'  => isset($settings['service'][$service]) ? $settings['service'][$service] : FALSE,
      '#title'          => $service,
      '#type'           => 'checkbox',
    );
  }

  // Servers
  $form['wsapi_settings']['server'] = array(
    '#type'         => 'fieldset',
    '#tree'         => TRUE,
    '#title'        => t('Server'),
  );
  foreach (module_implements('webservices_server_info') as $module) {
    $method = module_invoke($module, 'webservices_server_info');

    $form['wsapi_settings']['server'][$module] = array(
      '#default_value'  => isset($settings['server'][$module]) ? $settings['server'][$module] : FALSE,
      '#title'          => $method['#name'],
      '#type'           => 'checkbox',
    );
  }

  // Authentication Methods
  $form['wsapi_settings']['authentication'] = array(
    '#type'         => 'fieldset',
    '#tree'         => TRUE,
    '#title'        => t('Authentication'),
  );
  foreach (module_implements('webservices_auth_info') as $module) {
    $method = module_invoke($module, 'webservices_auth_info');

    $form['wsapi_settings']['authentication'][$module] = array(
      '#default_value'  => isset($settings['authentication'][$module]) ? $settings['authentication'][$module] : FALSE,
      '#title'          => $method['#name'],
      '#type'           => 'checkbox',
    );
  }

  // Put everything into 'wsapi_settings' variable automatically
  return system_settings_form($form);
}
